Public Class MainForm

    Private Const SND_FILENAME As Integer = &H20000
    Private Const SND_LOOP As Short = &H8S
    Private Const SND_ASYNC As Short = &H1S
    Private Const SND_NODEFAULT As Short = &H2

    Private Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (ByVal lpszName As String, ByVal hModule As Integer, ByVal dwFlags As Integer) As Boolean

    Private Sub ErrorMessages()

        Dim VaxObjectError As Object
        VaxObjectError = VaxSIPUserAgentOCX.GetVaxObjectError

        If VaxObjectError = 10 Then
            MsgBox("You are not Online, please click the 'Online' button first.")
        End If

        If VaxObjectError = 11 Then
            MsgBox("Cann't open local communication port. Another softphone (x-Ten, x-lite or skype etc) is already running. Please close it first.")
        End If

        If VaxObjectError = 12 Then
            MsgBox("License Key is not valid.")
        End If

        If VaxObjectError = 13 Then
            MsgBox("Fail to initialize VaxVoIP task window.")
        End If

        If VaxObjectError = 14 Then
            MsgBox("Cann't access Input/Mic device or device is already in use.")
        End If

        If VaxObjectError = 15 Then
            MsgBox("Cann't access Output/Speaker device or device is already in use.")
        End If

        If VaxObjectError = 16 Then
            MsgBox("Input/Mic device is not open.")
        End If

        If VaxObjectError = 17 Then
            MsgBox("Output/Speaker device is not open.")
        End If

        If VaxObjectError = 18 Then
            MsgBox("Your sound device does not support mic volume.")
        End If

        If VaxObjectError = 19 Then
            MsgBox("Your sound device does not support speaker volume.")
        End If

        If VaxObjectError = 20 Then
            MsgBox("Recording media initialization fail.")
        End If

        If VaxObjectError = 21 Then
            MsgBox("Cann't open the wave file.")
        End If

        If VaxObjectError = 22 Then
            MsgBox("Provided SIP URI is not valid.")
        End If

        If VaxObjectError = 23 Then
            MsgBox("Codec is not supported.")
        End If

        If VaxObjectError = 24 Then
            MsgBox("Error to create SDP (Session Description Protocol) request.")
        End If

        If VaxObjectError = 25 Then
            MsgBox("Error to create CONNECTION request. Please check the provided SIP URI is valid.")
        End If

        If VaxObjectError = 26 Then
            MsgBox("Error to create REGISTER request. Please check the provided SIP URI is valid.")
        End If

        If VaxObjectError = 27 Then
            MsgBox("Error to create UN-REGISTER request. Please check the provided SIP URI is valid.")
        End If

        If VaxObjectError = 28 Then
            MsgBox("Error to create DISCONNECT request.")
        End If

        If VaxObjectError = 29 Then
            MsgBox("Line No is not valid.")
        End If

        If VaxObjectError = 30 Then
            MsgBox("Line is already busy.")
        End If

        If VaxObjectError = 31 Then
            MsgBox("Line is not open.")
        End If

        If VaxObjectError = 32 Then
            MsgBox("Invalid Call-Id.")
        End If

        If VaxObjectError = 33 Then
            MsgBox("Provided value is not valid.")
        End If

        If VaxObjectError = 34 Then
            MsgBox("Selected line is not in voice session.")
        End If

        If VaxObjectError = 35 Then
            MsgBox("Fail to read wave file.")
        End If

        If VaxObjectError = 36 Then
            MsgBox("Fail to write wave file.")
        End If

        If VaxObjectError = 37 Then
            MsgBox("Unsupported wave file format.")
        End If

    End Sub

    Private Function InitVaxVoIPObject(ByVal MyIP As String, ByVal FromURI As String) As Boolean

        Dim ListenPort As Short
        Dim Result As Boolean

        Result = False
        ListenPort = 5060

        Do While ListenPort < 7000

            Result = VaxSIPUserAgentOCX.Initialize(False, MyIP, ListenPort, FromURI, EditOutBoundProxy.Text, EditSIPProxy.Text, EditLoginId.Text, EditLoginPwd.Text, True, 7)
            If Result = False Then

                If 11 <> VaxSIPUserAgentOCX.GetVaxObjectError() Then
                    ErrorMessages()
                    Exit Do
                End If

            Else
                Exit Do
            End If

            ListenPort = ListenPort + 1
        Loop

        If ListenPort >= 7000 Then
            MsgBox("Cann't open SIP communication port.")
            Result = False
        End If

        Return Result

    End Function

    Private Function OpenLines(ByVal MyIP As String, ByVal TotalNoOfLine As Short) As Boolean

        Dim LineNo As Integer
        Dim ListenPort As Short
        Dim Result As Boolean
        Dim ErrorCount As Integer

        Result = False
        ListenPort = 7000
        ErrorCount = 0

        For LineNo = 0 To (TotalNoOfLine - 1)

            Result = VaxSIPUserAgentOCX.OpenLine(LineNo, False, MyIP, ListenPort)
            If Result = False Then

                If 11 <> VaxSIPUserAgentOCX.GetVaxObjectError() Then
                    ErrorMessages()
                    Exit For
                Else
                    ErrorCount = ErrorCount + 1
                    LineNo = LineNo - 1
                End If

            End If

            ListenPort = ListenPort + 2 ' It is importent to increament RTP Listen port by 2

            If ErrorCount >= (TotalNoOfLine + 1000) Then  ' If unable to open more than 1000 ports.
                MsgBox("Unable to open RTP communication port.")
                Result = False
                Exit For
            End If

        Next LineNo

        Return Result

    End Function

    Private Sub BtnOnline_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnOnline.Click

        Dim Result As Boolean
        Dim MyIP As String
        Dim FromURI As String

        If BtnOnline.Text = "Offline" Then

            TimerTick.Enabled = False
            ProgressTimer.Enabled = False

            SpkProgBar.Value = 0
            MicProgBar.Value = 0

            VaxSIPUserAgentOCX.UnInitialize()

            BtnOnline.Text = "Online"
            Exit Sub

        End If

        If EditLoginId.Text = "" Then
            MsgBox("Please enter the SIP proxy Login Id.")
            Exit Sub
        End If

        If EditSIPProxy.Text = "" Then
            MsgBox("Please enter the SIP proxy address or URI.")
            Exit Sub
        End If

        VaxSIPUserAgentOCX.SetLicenceKey("TRIAL-LICENSE-KEY")

        '****** Constructing SIP From URI for IP Telephony *******
        If EditDisplayName.Text = "" Then
            FromURI = EditLoginId.Text & " <sip:" & EditLoginId.Text & "@" & EditSIPProxy.Text & ">"
        Else
            FromURI = EditDisplayName.Text & " <sip:" & EditLoginId.Text & "@" & EditSIPProxy.Text & ">"
        End If

        '********************************************************************
        '   Listen Port: default SIP port 5060.
        '     SIP Proxy: SIP Proxy IP or FQDN provided by your service provider.
        ' OutboundProxy: SIP outbound/NAT proxy IP or FQDN provided by your
        '                service provider to use SIP phone behind the NAT.
        '
        '*********************************************************************

        MyIP = VaxSIPUserAgentOCX.GetMyIP()

        Result = InitVaxVoIPObject(MyIP, FromURI)
        If Result = False Then
            Exit Sub
        End If

        Result = OpenLines(MyIP, 7)
        If Result = False Then
            Exit Sub
        End If

        If CheckRegisterToProxy.Checked Then
            Result = VaxSIPUserAgentOCX.RegisterToProxy(3600)
            If Result = False Then
                ErrorMessages()
                Exit Sub
            End If
            AddToStatusLog("Registering to SIP Proxy.")
        End If

        VaxSIPUserAgentOCX.EnableKeepAlive(10)

        If CheckRegisterToProxy.Checked = 1 Then
            Result = VaxSIPUserAgentOCX.RegisterToProxy(3600)
            If Result = False Then
                ErrorMessages()
                Exit Sub
            End If

            AddToStatusLog("Registering to SIP Proxy.")
        End If

        If CheckEchoCancel.Checked Then
            VaxSIPUserAgentOCX.EnableEchoNoiseCancellation()
        Else
            VaxSIPUserAgentOCX.DisableEchoNoiseCancellation()
        End If

        VaxSIPUserAgentOCX.DeselectAllVoiceCodec()

        If CheckGSM610.Checked Then
            VaxSIPUserAgentOCX.SelectVoiceCodec(0)
        End If

        If CheckiLBC.Checked Then
            VaxSIPUserAgentOCX.SelectVoiceCodec(1)
        End If

        If CheckG711A.Checked Then
            VaxSIPUserAgentOCX.SelectVoiceCodec(2)
        End If

        If CheckG711U.Checked Then
            VaxSIPUserAgentOCX.SelectVoiceCodec(3)
        End If

        BtnOnline.Text = "Offline"

        TimerTick.Enabled = True
        ProgressTimer.Enabled = True

        UpdateSoundDevices()

        TimerTick.Enabled = True
        ProgressTimer.Enabled = True

    End Sub

    Private Sub BtnDial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDial.Click

        Dim LineNo As Integer
        Dim ToURI As String
        Dim Result As Boolean

        If EditPhoneNo.Text = "" Then
            MsgBox("Please enter a phone number.")
            Exit Sub
        End If

        '*******************************************************
        '       Constructing SIP To URI for IP Telephony:
        '                sip:PhoneNumber@SIP Proxy
        '********************************************************

        ToURI = "sip:" & EditPhoneNo.Text & "@" & EditSIPProxy.Text

        LineNo = FindLine()
        If LineNo = -1 Then
            MsgBox("No line is free")
            Exit Sub
        End If

        Result = VaxSIPUserAgentOCX.Connect(LineNo, ToURI, ComboAudioIn.SelectedIndex - 1, ComboAudioOut.SelectedIndex - 1)
        If Result = False Then
            ErrorMessages()
        Else
            AddToStatusLog("Line-" & Str(LineNo + 1) & ": Dialing.")
            ListLines.Items.Item(LineNo) = "Line-" + Trim(Str(LineNo + 1)) + " : CONNECTING"
        End If
    End Sub


    Private Sub BtnClearLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearLog.Click
        ListStatusLog.Items.Clear()
    End Sub

    Private Sub BtnDialPad1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad1.Click
        EditPhoneNo.Text = EditPhoneNo.Text + "1"
        VaxSIPUserAgentOCX.DigitDTMF(ListLines.SelectedIndex, "1")
    End Sub

    Private Sub BtnDialPad2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad2.Click
        EditPhoneNo.Text = EditPhoneNo.Text + "2"
        VaxSIPUserAgentOCX.DigitDTMF(ListLines.SelectedIndex, "2")
    End Sub

    Private Sub BtnDialPad3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad3.Click
        EditPhoneNo.Text = EditPhoneNo.Text + "3"
        VaxSIPUserAgentOCX.DigitDTMF(ListLines.SelectedIndex, "3")
    End Sub

    Private Sub BtnDialPad4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad4.Click
        EditPhoneNo.Text = EditPhoneNo.Text + "4"
        VaxSIPUserAgentOCX.DigitDTMF(ListLines.SelectedIndex, "4")
    End Sub

    Private Sub BtnDialPad5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad5.Click
        EditPhoneNo.Text = EditPhoneNo.Text + "5"
        VaxSIPUserAgentOCX.DigitDTMF(ListLines.SelectedIndex, "5")
    End Sub

    Private Sub BtnDialPad6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad6.Click
        EditPhoneNo.Text = EditPhoneNo.Text + "6"
        VaxSIPUserAgentOCX.DigitDTMF(ListLines.SelectedIndex, "6")
    End Sub

    Private Sub BtnDialPad7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad7.Click
        EditPhoneNo.Text = EditPhoneNo.Text + "7"
        VaxSIPUserAgentOCX.DigitDTMF(ListLines.SelectedIndex, "7")
    End Sub

    Private Sub BtnDialPad8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad8.Click
        EditPhoneNo.Text = EditPhoneNo.Text + "8"
        VaxSIPUserAgentOCX.DigitDTMF(ListLines.SelectedIndex, "8")
    End Sub

    Private Sub BtnDialPad9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad9.Click
        EditPhoneNo.Text = EditPhoneNo.Text + "9"
        VaxSIPUserAgentOCX.DigitDTMF(ListLines.SelectedIndex, "9")
    End Sub

    Private Sub BtnDialPadStar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPadStar.Click
        VaxSIPUserAgentOCX.DigitDTMF(ListLines.SelectedIndex, "*")
    End Sub

    Private Sub BtnDialPad0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad0.Click
        EditPhoneNo.Text = EditPhoneNo.Text + "0"
        VaxSIPUserAgentOCX.DigitDTMF(ListLines.SelectedIndex, "0")
    End Sub

    Private Sub BtnDialPadNo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPadNo.Click
        VaxSIPUserAgentOCX.DigitDTMF(ListLines.SelectedIndex, "#")
    End Sub

    Private Sub BtnHangUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHangUp.Click

        Dim LineNo As Integer
        Dim Result As Boolean

        LineNo = ListLines.SelectedIndex
        Result = VaxSIPUserAgentOCX.Disconnect(LineNo)
        If Result = False Then
            ErrorMessages()
        End If

    End Sub

    Private Sub BtnResetRecordingBuffer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnResetRecordingBuffer.Click

        Dim LineNo As Integer
        LineNo = ListLines.SelectedIndex

        VaxSIPUserAgentOCX.ResetRecording(LineNo)

    End Sub

    Private Sub BtnSaveToWaveFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSaveToWaveFile.Click

        Dim LineNo As Integer
        Dim Result As Boolean

        LineNo = ListLines.SelectedIndex

        Result = VaxSIPUserAgentOCX.SaveRecordingToWaveFile(LineNo, EditSaveFileName.Text)
        If Result = False Then
            ErrorMessages()
            Exit Sub
        End If

        MsgBox("Saved Successfully")
    End Sub

    Private Sub RemoveCallIdFromList(ByVal CallId As String)

        Dim ListIndex As Integer
        ListIndex = ListIncomingCallIds.FindString(CallId)
        If ListIndex = -1 Then
            Exit Sub
        End If

        ListIncomingCall.Items.RemoveAt(ListIndex)
        ListIncomingCallIds.Items.RemoveAt(ListIndex)

    End Sub

    Private Sub BtnAccept_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAccept.Click

        Dim Result As Boolean
        Dim LineNo As Integer
        Dim CallId As String
        Dim SelectedItemIndex As Integer

        SelectedItemIndex = ListIncomingCall.SelectedIndex
        If SelectedItemIndex = -1 Then
            Exit Sub
        End If

        CallId = ListIncomingCallIds.Items.Item(SelectedItemIndex)

        LineNo = FindLine()
        If LineNo = -1 Then
            MsgBox("No line is free")
            Exit Sub
        End If

        Result = VaxSIPUserAgentOCX.AcceptCall(LineNo, CallId, ComboAudioIn.SelectedIndex - 1, ComboAudioOut.SelectedIndex - 1)
        If Result = False Then
            ErrorMessages()
        End If

        PlaySound(vbNullString, 0&, 0)
        RemoveCallIdFromList(CallId)

        If ListIncomingCall.SelectedIndex = -1 And ListIncomingCall.Items.Count > 0 Then
            ListIncomingCall.SelectedIndex = 0
        End If

        ListLines.Items.Item(LineNo) = "Line-" + Trim(Str(LineNo + 1)) + " : CONNECTING"

    End Sub

    Private Sub BtnReject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnReject.Click

        Dim Result As Boolean
        Dim CallId As String
        Dim SelectedItemIndex As Integer

        SelectedItemIndex = ListIncomingCall.SelectedIndex
        If SelectedItemIndex = -1 Then
            Exit Sub
        End If

        CallId = ListIncomingCallIds.Items.Item(SelectedItemIndex)

        Result = VaxSIPUserAgentOCX.RejectCall(CallId)
        If Result = False Then
            ErrorMessages()
        End If

        PlaySound(vbNullString, 0&, 0)
        RemoveCallIdFromList(CallId)

        If ListIncomingCall.SelectedIndex = -1 And ListIncomingCall.Items.Count > 0 Then
            ListIncomingCall.SelectedIndex = 0
        End If

    End Sub

    Private Sub BtnSetPlayFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSetPlayFile.Click

        Dim Result As Boolean
        Dim LineNo As Integer

        LineNo = ListLines.SelectedIndex

        Result = VaxSIPUserAgentOCX.PlayWaveOpen(LineNo, EditPlayFileName.Text)
        If Result = False Then
            ErrorMessages()
        End If

    End Sub

    Private Sub BtnStartPlay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnStartPlay.Click

        Dim Result As Boolean
        Dim LineNo As Integer

        LineNo = ListLines.SelectedIndex

        Result = VaxSIPUserAgentOCX.PlayWaveStart(LineNo, CheckPlayListen.Checked)
        If Result = False Then
            ErrorMessages()
        End If

    End Sub

    Private Sub BtnPlayRewind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPlayRewind.Click

        Dim Result As Boolean
        Dim LineNo As Integer

        LineNo = ListLines.SelectedIndex

        Result = VaxSIPUserAgentOCX.PlayWaveSkipTo(LineNo, VaxSIPUserAgentOCX.PlayWavePosition(LineNo) - 2)
        If Result = False Then
            ErrorMessages()
        End If

    End Sub

    Private Sub BtnPlayForward_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPlayForward.Click

        Dim Result As Boolean
        Dim LineNo As Integer

        LineNo = ListLines.SelectedIndex

        Result = VaxSIPUserAgentOCX.PlayWaveSkipTo(LineNo, VaxSIPUserAgentOCX.PlayWavePosition(LineNo) + 2)
        If Result = False Then
            ErrorMessages()
        End If

    End Sub

    Private Sub BtnPlayPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPlayPause.Click

        Dim Result As Boolean
        Dim LineNo As Integer

        LineNo = ListLines.SelectedIndex

        Result = VaxSIPUserAgentOCX.PlayWavePause(LineNo)
        If Result = False Then
            ErrorMessages()
        End If

    End Sub

    Private Sub BtnPlayStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPlayStop.Click

        Dim Result As Boolean
        Dim LineNo As Integer

        LineNo = ListLines.SelectedIndex

        Result = VaxSIPUserAgentOCX.PlayWaveStop(LineNo)
        If Result = False Then
            ErrorMessages()
        End If

    End Sub

    Private Sub CheckEchoCancel_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckEchoCancel.CheckedChanged

        If CheckEchoCancel.Checked = True Then
            VaxSIPUserAgentOCX.EnableEchoNoiseCancellation()
        Else
            VaxSIPUserAgentOCX.DisableEchoNoiseCancellation()
        End If

    End Sub

    Private Sub CheckAGC_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckAGC.CheckedChanged

        Dim Result As Boolean

        If CheckAGC.Checked = True Then
            Result = VaxSIPUserAgentOCX.EnableAGC(8000)
            If Result = False Then
                ErrorMessages()
            End If
        Else
            VaxSIPUserAgentOCX.DisableAGC()
        End If

    End Sub

    Private Sub CheckMicBoost_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckMicBoost.CheckedChanged

        If CheckMicBoost.Checked = True Then
            VaxSIPUserAgentOCX.EnableMicBoost()
        Else
            VaxSIPUserAgentOCX.DisableMicBoost()
        End If

    End Sub

    Private Sub CheckDisturb_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckDisturb.CheckedChanged

        If CheckDisturb.Checked = True Then
            VaxSIPUserAgentOCX.EnableDonotDisturb()
        Else
            VaxSIPUserAgentOCX.DisableDonotDisturb()
        End If

    End Sub

    Private Sub CheckGSM610_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckGSM610.CheckedChanged

        '****Codec No 0 represents GSM 6.10 *****

        If CheckGSM610.Checked = True Then
            VaxSIPUserAgentOCX.SelectVoiceCodec(0)
        Else
            VaxSIPUserAgentOCX.DeselectVoiceCodec(0)
        End If

    End Sub

    Private Sub CheckiLBC_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckiLBC.CheckedChanged

        '****Codec No 1 represents iLBC *****

        If CheckiLBC.Checked = 1 Then
            VaxSIPUserAgentOCX.SelectVoiceCodec(1)
        Else
            VaxSIPUserAgentOCX.DeselectVoiceCodec(1)
        End If

    End Sub

    Private Sub CheckG711A_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckG711A.CheckedChanged

        '****Codec No 2 represents G711 A-LAW *****

        If CheckG711A.Checked = True Then
            VaxSIPUserAgentOCX.SelectVoiceCodec(2)
        Else
            VaxSIPUserAgentOCX.DeselectVoiceCodec(2)
        End If

    End Sub

    Private Sub CheckG711U_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckG711U.CheckedChanged

        '****Codec No 3 represents G711 U-LAW *****

        If CheckG711U.Checked = True Then
            VaxSIPUserAgentOCX.SelectVoiceCodec(3)
        Else
            VaxSIPUserAgentOCX.DeselectVoiceCodec(3)
        End If

    End Sub

    Private Sub BtnTransferCall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnTransferCall.Click

        Dim Result As Boolean
        Dim LineNo As Integer
        Dim ToURI As String

        ToURI = "sip:" & EditTransferPhoneNo.Text & "@" & EditSIPProxy.Text

        LineNo = ListLines.SelectedIndex

        Result = VaxSIPUserAgentOCX.TransferCall(LineNo, ToURI)
        If Result = False Then
            ErrorMessages()
        End If

    End Sub

    Private Sub CheckSpkMute_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckSpkMute.CheckedChanged
        VaxSIPUserAgentOCX.MuteSpk(CheckSpkMute.Checked)
    End Sub

    Private Sub CheckMuteMic_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckMuteMic.CheckedChanged
        VaxSIPUserAgentOCX.MuteMic(CheckMuteMic.Checked)
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnCallTransferAccepted(ByVal sender As Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnCallTransferAcceptedEvent) Handles VaxSIPUserAgentOCX.OnCallTransferAccepted
        AddToStatusLog("Line-" & Str(e.lineNo + 1) & ": Transfer accepted.")
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnConnecting(ByVal sender As Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnConnectingEvent) Handles VaxSIPUserAgentOCX.OnConnecting
        AddToStatusLog("Line-" & Str(e.lineNo + 1) & ": Connecting.")
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnDisconnectCall(ByVal sender As Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnDisconnectCallEvent) Handles VaxSIPUserAgentOCX.OnDisconnectCall
        AddToStatusLog("Line-" & Str(e.lineNo + 1) & ": Hung up.")
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnFailToConnect(ByVal sender As Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnFailToConnectEvent) Handles VaxSIPUserAgentOCX.OnFailToConnect
        AddToStatusLog("Line-" & Str(e.lineNo + 1) & ": Fail to connect.")
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnFailToRegister(ByVal sender As Object, ByVal e As System.EventArgs) Handles VaxSIPUserAgentOCX.OnFailToRegister
        AddToStatusLog("Fail to register.")
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnFailToUnRegister(ByVal sender As Object, ByVal e As System.EventArgs) Handles VaxSIPUserAgentOCX.OnFailToUnRegister
        AddToStatusLog("Fail to unregister.")
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnGeneralFailureResponse(ByVal sender As Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnGeneralFailureResponseEvent) Handles VaxSIPUserAgentOCX.OnGeneralFailureResponse
        AddToStatusLog("Line-" & Str(e.lineNo + 1) & " Response: " & e.reasonPhrase)
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnIncomingCall(ByVal sender As Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnIncomingCallEvent) Handles VaxSIPUserAgentOCX.OnIncomingCall

        If ListIncomingCallIds.FindString(e.callId) = -1 Then
            ListIncomingCallIds.Items.Add(e.callId)

            If e.displayName.Length <> 0 Then
                ListIncomingCall.Items.Add("CLI: " & e.displayName)
            Else
                ListIncomingCall.Items.Add("CLI: " & e.userName)
            End If


        End If

        If ListIncomingCall.SelectedIndex = -1 And ListIncomingCall.Items.Count > 0 Then
            ListIncomingCall.SelectedIndex = 0
        End If

    End Sub

    Private Sub VaxSIPUserAgentOCX_OnIncomingCallRingingStart(ByVal sender As Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnIncomingCallRingingStartEvent) Handles VaxSIPUserAgentOCX.OnIncomingCallRingingStart

        If CheckPlayRingTone.Checked = True Then
            PlaySound("ring.wav", 0&, SND_ASYNC Or SND_FILENAME Or SND_LOOP Or SND_NODEFAULT)
        End If

    End Sub

    Private Sub VaxSIPUserAgentOCX_OnIncomingCallRingingStop(ByVal sender As Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnIncomingCallRingingStopEvent) Handles VaxSIPUserAgentOCX.OnIncomingCallRingingStop
        RemoveCallIdFromList(e.callId)
        PlaySound(vbNullString, 0&, 0)
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnPlayWaveDone(ByVal sender As Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnPlayWaveDoneEvent) Handles VaxSIPUserAgentOCX.OnPlayWaveDone
        AddToStatusLog("Line-" & Str(e.lineNo + 1) & ": Play wave done.")
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnProvisionalResponse(ByVal sender As Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnProvisionalResponseEvent) Handles VaxSIPUserAgentOCX.OnProvisionalResponse
        AddToStatusLog("Line-" & Str(e.lineNo + 1) & ": Response: " & e.reasonPhrase)
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnRedirectionResponse(ByVal sender As Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnRedirectionResponseEvent) Handles VaxSIPUserAgentOCX.OnRedirectionResponse
        AddToStatusLog("Line-" & Str(e.lineNo + 1) & ": Response: " & e.reasonPhrase)
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnRequestFailureResponse(ByVal sender As Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnRequestFailureResponseEvent) Handles VaxSIPUserAgentOCX.OnRequestFailureResponse
        AddToStatusLog("Line-" & Str(e.lineNo + 1) & ": Response: " & e.reasonPhrase)
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnServerFailureResponse(ByVal sender As Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnServerFailureResponseEvent) Handles VaxSIPUserAgentOCX.OnServerFailureResponse
        AddToStatusLog("Line-" & Str(e.lineNo + 1) & ": Response: " & e.reasonPhrase)
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnSuccessToConnect(ByVal sender As Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnSuccessToConnectEvent) Handles VaxSIPUserAgentOCX.OnSuccessToConnect

        Dim Result As Integer

        If e.lineNo <> ListLines.SelectedIndex Then
            VaxSIPUserAgentOCX.HoldLine(e.lineNo)
            ListLines.Items.Item(e.lineNo) = "Line-" + Trim(Str(e.lineNo + 1)) + " : HOLD"
        Else
            ListLines.Items.Item(e.lineNo) = "Line-" + Trim(Str(e.lineNo + 1)) + " : BUSY"
        End If

        AddToStatusLog("Line-" & Str(e.lineNo + 1) & ": Success to connect.")

        Result = VaxSIPUserAgentOCX.GetSpkVolume()
        SliderSpkVol.Value = Result / 25

        Result = VaxSIPUserAgentOCX.GetMicVolume()
        SliderMicVol.Value = Result / 25

        CheckMicBoost.Checked = VaxSIPUserAgentOCX.IsMicBoostEnable()

    End Sub

    Private Sub VaxSIPUserAgentOCX_OnSuccessToRegister(ByVal sender As Object, ByVal e As System.EventArgs) Handles VaxSIPUserAgentOCX.OnSuccessToRegister
        AddToStatusLog("Registered successfully.")
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnSuccessToUnRegister(ByVal sender As Object, ByVal e As System.EventArgs) Handles VaxSIPUserAgentOCX.OnSuccessToUnRegister
        AddToStatusLog("Unregistered successfully.")
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnTryingToRegister(ByVal sender As Object, ByVal e As System.EventArgs) Handles VaxSIPUserAgentOCX.OnTryingToRegister
        AddToStatusLog("Trying to register.")
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnTryingToUnRegister(ByVal sender As Object, ByVal e As System.EventArgs) Handles VaxSIPUserAgentOCX.OnTryingToUnRegister
        AddToStatusLog("Trying to Unregister.")
    End Sub

    Private Sub SliderSpkVol_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs)

        ' SetSpkVolume method requires Volume value from 0 to 255 range    '
        ' but the slider range is 0 to 10, so we multiply the slider value '
        ' to 25 to get the required value to pass to SetSpkVolume method   '

        VaxSIPUserAgentOCX.SetSpkVolume(SliderSpkVol.Value * 25)

    End Sub

    Private Sub SliderMicVol_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs)

        ' SetMicVolume method requires Volume value from 0 to 255 range    '
        ' but the slider range is 0 to 10, so we multiply the slider value '
        ' to 25 to get the required value to pass to SetMicVolume method   '

        VaxSIPUserAgentOCX.SetMicVolume(SliderMicVol.Value * 25)

    End Sub

    Private Sub UpdateSoundDevices()

        Dim DeviceId As Integer

        ComboAudioIn.Items.Clear()
        ComboAudioIn.Items.Add("Default Device")

        For DeviceId = 0 To VaxSIPUserAgentOCX.GetAudioInDevTotal() - 1
            ComboAudioIn.Items.Add(VaxSIPUserAgentOCX.GetAudioInDevName(DeviceId))
        Next DeviceId

        ComboAudioIn.SelectedIndex = 0

        ComboAudioOut.Items.Clear()
        ComboAudioOut.Items.Add("Default Device")

        For DeviceId = 0 To VaxSIPUserAgentOCX.GetAudioOutDevTotal() - 1
            ComboAudioOut.Items.Add(VaxSIPUserAgentOCX.GetAudioOutDevName(DeviceId))
        Next DeviceId

        ComboAudioOut.SelectedIndex = 0

    End Sub

    Private Function FindLine() As Integer

        Dim LineNo As Integer
        LineNo = ListLines.SelectedIndex

        If VaxSIPUserAgentOCX.IsLineBusy(LineNo) = False Then
            FindLine = LineNo
            Exit Function
        End If

        For LineNo = 0 To 6

            If VaxSIPUserAgentOCX.IsLineBusy(LineNo) = False Then
                FindLine = LineNo
                Exit Function
            End If

        Next LineNo

        FindLine = -1

    End Function

    Private Sub UpdateListLine(ByVal LineNo As Integer)

        Dim LineCount As Integer

        If CheckStartConf.Checked Then
            For LineCount = 0 To 6
                If VaxSIPUserAgentOCX.IsLineHold(LineCount) Then
                    VaxSIPUserAgentOCX.UnHoldLine(LineCount)
                End If
            Next LineCount
        Else

            For LineCount = 0 To 6
                If LineCount <> LineNo Then
                    If ((VaxSIPUserAgentOCX.IsLineBusy(LineCount) = True) And (VaxSIPUserAgentOCX.IsLineHold(LineCount) = False)) Then
                        VaxSIPUserAgentOCX.HoldLine(LineCount)
                    End If
                End If
            Next LineCount

            If VaxSIPUserAgentOCX.IsLineHold(LineNo) Then
                VaxSIPUserAgentOCX.UnHoldLine(LineNo)
            End If

        End If

    End Sub

    Private Sub TimerTick_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerTick.Tick

        Dim ItemText As String
        Dim LineNo As Integer

        If ListLines.Items.Count() = 0 Then
            For LineNo = 0 To 6
                ListLines.Items.Add("Line-" + Trim(Str(LineNo + 1)) + " : FREE")
            Next LineNo

            ListLines.SelectedIndex = 0
        End If

        UpdateListLine(ListLines.SelectedIndex)

        If (VaxSIPUserAgentOCX.IsRecording(ListLines.SelectedIndex) = True) <> (CheckStartRecording.Checked = True) Then
            If VaxSIPUserAgentOCX.IsRecording(ListLines.SelectedIndex) Then
                CheckStartRecording.Checked = True
            Else
                CheckStartRecording.Checked = False
            End If
        End If

        For LineNo = 0 To 6

            ItemText = ListLines.Items.Item(LineNo)

            If VaxSIPUserAgentOCX.IsLineOpen(LineNo) = False Then

                If ItemText.IndexOf("CLOSE") = -1 Then
                    ListLines.Items.Item(LineNo) = "Line-" + Trim(Str(LineNo + 1)) + " : CLOSE"
                End If

            Else
                If VaxSIPUserAgentOCX.IsLineBusy(LineNo) = True Then

                    If VaxSIPUserAgentOCX.IsWaveFilePlaying(LineNo) = True Then
                        If ItemText.IndexOf("PLAYING") = -1 Then
                            ListLines.Items.Item(LineNo) = "Line-" + Trim(Str(LineNo + 1)) + " : PLAYING"
                        End If
                    Else
                        If VaxSIPUserAgentOCX.IsLineHold(LineNo) = True Then
                            If ItemText.IndexOf("HOLD") = -1 Then
                                ListLines.Items.Item(LineNo) = "Line-" + Trim(Str(LineNo + 1)) + " : HOLD"
                            End If
                        Else
                            If (ItemText.IndexOf("BUSY") = -1) And (ItemText.IndexOf("CONNECTING") = -1) Then
                                ListLines.Items.Item(LineNo) = "Line-" + Trim(Str(LineNo + 1)) + " : BUSY"
                            End If
                        End If
                    End If
                Else
                    If ItemText.IndexOf("FREE") = -1 Then
                        ListLines.Items.Item(LineNo) = "Line-" + Trim(Str(LineNo + 1)) + " : FREE"
                    End If
                End If

            End If

        Next LineNo

    End Sub

    Private Sub CheckPlayRingTone_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckPlayRingTone.CheckedChanged

        If CheckPlayRingTone.Checked = False Then
            PlaySound(vbNullString, 0&, 0)
        End If

    End Sub

    Private Sub BtnHelpMore_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHelpMore.Click
        HelpForm.ShowDialog()
    End Sub

    Private Sub VaxSIPUserAgentOCX_OnDTMFDigit(ByVal sender As System.Object, ByVal e As AxVAXSIPUSERAGENTOCXLib._DVaxSIPUserAgentOCXEvents_OnDTMFDigitEvent) Handles VaxSIPUserAgentOCX.OnDTMFDigit
        AddToStatusLog("Line-" & Str(e.lineNo + 1) & ": Key-pressed: " & e.digit)
    End Sub

    Private Sub MainForm_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        PlaySound(vbNullString, 0&, 0)
    End Sub

    Private Sub ProgressTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProgressTimer.Tick
        SpkProgBar.Value = VaxSIPUserAgentOCX.GetSpkSoundLevel()
        MicProgBar.Value = VaxSIPUserAgentOCX.GetMicSoundLevel()
    End Sub

    Private Sub AddToStatusLog(ByVal StatusLog As String)
        ListStatusLog.Items.Add(StatusLog)
        ListStatusLog.TopIndex = ListStatusLog.Items.Count - 1
    End Sub

    Private Sub CheckStartRecording_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckStartRecording.CheckedChanged
        Dim Result As Boolean
        Dim LineNo As Integer

        LineNo = ListLines.SelectedIndex

        If CheckStartRecording.Checked = True Then
            Result = VaxSIPUserAgentOCX.StartRecording(LineNo, 2, True)
            If Result = False Then
                ErrorMessages()
            End If
        Else
            Result = VaxSIPUserAgentOCX.StopRecording(LineNo)
        End If
    End Sub

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        CheckEchoCancel.Checked = True

        CheckGSM610.Checked = True
        CheckiLBC.Checked = True
        CheckG711A.Checked = True
        CheckG711U.Checked = True

    End Sub

    Private Sub CheckStartConf_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckStartConf.CheckedChanged
        Dim BusyCount As Integer
        Dim LineNo As Integer

        For LineNo = 0 To 6
            If VaxSIPUserAgentOCX.IsLineBusy(LineNo) = True Then
                BusyCount = BusyCount + 1
            End If
        Next LineNo

        If BusyCount < 2 And CheckStartConf.Checked Then
            CheckStartConf.Checked = False
            MessageBox.Show("Dial/receive more than one calls and then click start conference check box.", "VaxVoIP SDK")
        End If
    End Sub
End Class
